export class SemanticError extends Error {
  constructor (msg, id) {
    super(...msg);
    this.id = id;
    if (Error.captureStackTrace) Error.captureStackTrace(this, SemanticError);
  }

  get context () {
    return this._context;
  }

  set context (contextObj) {
    this._context = contextObj;
  }
}

